package cn.iocoder.yudao.module.reward.dal.dataobject.reward;

import cn.iocoder.yudao.framework.mybatis.core.dataobject.BaseDO;
import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.*;

import java.util.Date;
import java.util.List;

/**
 * 礼品 DO
 *
 * @author 系统管理员
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@TableName("ecw_reward")
@EqualsAndHashCode(callSuper = true)
@ToString(callSuper = true)
public class RewardDO extends BaseDO {

    /**
     * 主键
     */
    @TableId
    private Long id;
    /**
     * 礼品ID
     */
    private String code;
    /**
     * 中文名称
     */
    private String titleZh;
    /**
     * 英文名称
     */
    private String titleEn;
    /**
     * 法文名称
     */
    private String titleFr;
    /**
     * 中文礼品图片
     */
    private String imgZh;
    /**
     * 英文礼品图片
     */
    private String imgEn;
    /**
     * 法文礼品图片
     */
    private String imgFr;
    /**
     * 兑换所需积分
     */
    private Integer pointsRequire;
    /**
     * 兑换网点
     */
    private Integer nodeId;
    /**
     * 已兑换次数
     */
    private Integer exchangeCount;
    /**
     * 剩余数量
     */
    private Integer quantityRemain;
    /**
     * 活动开始时间
     */
    private Date startTime;
    /**
     * 活动结束时间
     */
    private Date endTime;
    /**
     * 领取方式（1上门领取，2包邮到家，3邮寄到付）
     * TODO ：改为枚举
     */
    private String pickMethod;
    /**
     * 允许兑换次数
     */
    private Integer allowCount;
    /**
     * 中文备注
     */
    private String remarkZh;
    /**
     * 英文备注
     */
    private String remarkEn;
    /**
     * 法文备注
     */
    private String remarkFr;
    /**
     * 礼品状态（1已启用，2未启用，3已关闭，4已过期）
     * TODO ：改为枚举
     */
    private Integer status;

}
