package cn.iocoder.yudao.module.reward.dal.mysql.reward;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.mapper.AbstractMapper;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQuery;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.module.reward.dal.dataobject.reward.RewardDO;
import cn.iocoder.yudao.module.reward.vo.reward.RewardQueryVO;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

/**
 * 礼品 Mapper
 * @author 系统管理员
 */
@Mapper
public interface RewardMapper extends AbstractMapper<RewardDO> {
    @Override
    default PageResult<RewardDO> selectPage(PageVO page, Object object) {
        if (object instanceof RewardQueryVO) {
            RewardQueryVO vo = (RewardQueryVO)object;
            return selectPage(page, new LambdaQuery<RewardDO>()
                .eqIfPresent(RewardDO::getCode, vo.getCode())
                .eqIfPresent(RewardDO::getTitleZh, vo.getTitle())
                .eqIfPresent(RewardDO::getTitleEn, vo.getTitle())
                .eqIfPresent(RewardDO::getTitleFr, vo.getTitle())
                .eqIfPresent(RewardDO::getPointsRequire, vo.getPointsRequire())
                .eqIfPresent(RewardDO::getNodeId, vo.getNodeId())
                .eqIfPresent(RewardDO::getQuantityRemain, vo.getQuantityRemain())
                .eqIfPresent(RewardDO::getPickMethod, vo.getPickMethod())
                .eqIfPresent(RewardDO::getStatus, vo.getStatus())
                .betweenIfPresent(RewardDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(RewardDO::getId));
        }

        return null;
    }

    @Override
    default List<RewardDO> selectList(Object object) {
        if (object instanceof RewardQueryVO) {
            RewardQueryVO vo = (RewardQueryVO)object;
            return selectList(new LambdaQuery<RewardDO>()
                .eqIfPresent(RewardDO::getCode, vo.getCode())
                .eqIfPresent(RewardDO::getTitleZh, vo.getTitle())
                .eqIfPresent(RewardDO::getTitleEn, vo.getTitle())
                .eqIfPresent(RewardDO::getTitleFr, vo.getTitle())
                .eqIfPresent(RewardDO::getPointsRequire, vo.getPointsRequire())
                .eqIfPresent(RewardDO::getNodeId, vo.getNodeId())
                .eqIfPresent(RewardDO::getQuantityRemain, vo.getQuantityRemain())
                .eqIfPresent(RewardDO::getPickMethod, vo.getPickMethod())
                .eqIfPresent(RewardDO::getStatus, vo.getStatus())
                .betweenIfPresent(RewardDO::getCreateTime, vo.getBeginCreateTime(), vo.getEndCreateTime())
                    .orderByDesc(RewardDO::getId));
        }

        return null;
    }
}
