package cn.iocoder.yudao.module.reward.vo.reward;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@Data
@ApiModel("管理后台 - 礼品查询 VO")
public class RewardQueryVO {

    @ApiModelProperty(value = "礼品ID")
    private String code;

    @ApiModelProperty(value = "名称（不区分语言）")
    private String title;

    @ApiModelProperty(value = "兑换所需积分")
    private Integer pointsRequire;

    @ApiModelProperty(value = "兑换所需积分查询条件（1大于，2等于，3小于）")
    private Integer pointsRequireSymbol;

    @ApiModelProperty(value = "兑换网点")
    private Integer nodeId;

    @ApiModelProperty(value = "剩余数量")
    private Integer quantityRemain;

    @ApiModelProperty(value = "剩余数量查询条件（1大于，2等于，3小于）")
    private Integer quantityRemainSymbol;

    @ApiModelProperty(value = "领取方式（1上门领取，2包邮到家，3邮寄到付）")
    private String pickMethod;

    @ApiModelProperty(value = "礼品状态（1已启用，2未启用，3已关闭，4已过期）")
    private Integer status;

    @ApiModelProperty(value = "备注（不区分语言）")
    private String remark;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "开始创建时间")
    private Date beginCreateTime;

    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    @ApiModelProperty(value = "结束创建时间")
    private Date endCreateTime;

}
